﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace howto_bitwise_operators
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            cboOperator.SelectedIndex = 0;
        }

        private void cboOperator_SelectedIndexChanged(object sender, EventArgs e)
        {
            Calculate();
        }

        private void txt_TextChanged(object sender, EventArgs e)
        {
            Calculate();
        }

        private void Calculate()
        {
            txtResult.Clear();
            txtDecimalOperand2.Clear();
            txtDecimalOperand1.Clear();
            txtDecimalResult.Clear();

            try
            {
                // Convert the binary inputs into integers.
                int operand1 = Convert.ToInt32(txtOperand1.Text, 2);
                int operand2 = Convert.ToInt32(txtOperand2.Text, 2);

                // Calculate the result.
                int result = 0;
                switch (cboOperator.Text)
                {
                    case "&":
                        result = (operand1 & operand2);
                        break;
                    case "|":
                        result = (operand1 | operand2);
                        break;
                    case "^":
                        result = (operand1 ^ operand2);
                        break;
                    case "<<":
                        result = (operand1 << operand2);
                        break;
                    case ">>":
                        result = (operand1 >> operand2);
                        break;
                    case "~":
                        result = ~operand1;
                        break;
                }

                // Display the result in binary.
                int len = Math.Max(
                    txtOperand1.Text.Length,
                    txtOperand2.Text.Length);
                txtResult.Text = Convert.ToString(result, 2).PadLeft(len,'0');

                // Show the values in decimal.
                txtDecimalOperand1.Text = operand1.ToString();
                txtDecimalOperand2.Text = operand2.ToString();
                txtDecimalResult.Text = result.ToString();
            }
            catch
            {
            }
        }
    }
}
